NeuralEngine A Game Engine with embeded Machine Learning algorithms based on Gaussian Processes. |

Public Member Functions | List of all members
NeuralEngine::MachineLearning::IGradientOptimizationMethod< Scalar > Class Template Referenceabstract

Common interface for function optimization methods which depend on having both an objective function and a gradient function definition available. More...

`#include <IGradientOptimizationMethod.h>`

Inheritance diagram for NeuralEngine::MachineLearning::IGradientOptimizationMethod< Scalar >:
[legend]
Collaboration diagram for NeuralEngine::MachineLearning::IGradientOptimizationMethod< Scalar >:
[legend]

## Public Member Functions
virtual af::array | GetGradient ()=0
| Gets a function returning the gradient vector of the function to be optimized for a given value of its free parameters. More...
virtual void | SetGradient (af::array g)=0
| Sets a function returning the gradient vector of the function to be optimized for a given value of its free parameters. More...
Public Member Functions inherited from NeuralEngine::MachineLearning::IOptimizationMethod< Scalar >
virtual int | GetNumberOfVariables ()=0
| Gets the number of variables (free parameters) in the optimization problem. More...
virtual af::array | GetSolution ()=0
| Gets the current solution found, the values of the parameters which optimizes the function. More...
virtual void | SetSolution (af::array &x)=0
| Gets a solution. More...
virtual Scalar | GetValue ()=0
| Gets the output of the function at the current Solution. More...
virtual bool | Minimize (int *cycle=nullptr)=0
| Finds the minimum value of a function. The solution vector will be made available at the Solution property. More...
virtual bool | Maximize (int *cycle=nullptr)=0
| Finds the maximum value of a function. The solution vector will be made available at the Solution property. More...

## Detailed Description

template<typename Scalar>
class NeuralEngine::MachineLearning::IGradientOptimizationMethod< Scalar >

Common interface for function optimization methods which depend on having both an objective function and a gradient function definition available.

HmetalT, 16.03.2017.

See also
  BroydenFletcherGoldfarbShanno, ConjugateGradient, ResilientBackpropagation

Definition at line 34 of file IGradientOptimizationMethod.h.

## Member Function Documentation

## ◆ GetGradient()

template<typename Scalar >

virtual af::array NeuralEngine::MachineLearning::IGradientOptimizationMethod< Scalar >::GetGradient | ( |  | ) |
| pure virtual

Gets a function returning the gradient vector of the function to be optimized for a given value of its free parameters.

HmetalT, 16.03.2017.

Returns
  The gradient function.

## ◆ SetGradient()

template<typename Scalar >

virtual void NeuralEngine::MachineLearning::IGradientOptimizationMethod< Scalar >::SetGradient | ( | af::array | g | ) |
| pure virtual

Sets a function returning the gradient vector of the function to be optimized for a given value of its free parameters.

HmetalT, 16.03.2017.

Parameters

  parameter1 | The first parameter.

The documentation for this class was generated from the following file:

- IGradientOptimizationMethod.h